//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <stdio.h>
#include <math.h>
#include "main.h"
#include "ChildWin.h"


#ifndef min
#define min(a, b)  (((a) < (b)) ? (a) : (b))
#endif

#ifndef max
#define max(a, b)  (((a) > (b)) ? (a) : (b))
#endif

#ifndef PI
#define PI 3.1415926535897932385
#endif

#ifndef BM
#define BM 180/PI
#endif

//---------------------------------------------------------------------
#pragma resource "*.dfm"
//---------------------------------------------------------------------
__fastcall TMDIChild::TMDIChild(TComponent *Owner)
	: TForm(Owner)
{
	stlist=NULL;
	pltlist=NULL;
	pltlast=NULL;
	CurrX=0; CurrY=0;
	lastpen=0;
	is_crosshair=0;
	dis_crosshair=0;
	area_x = area_y = area_x1 = area_y1 = 0;
	zoom=1.0;
	marked=false;
	smX = smY = amX = amY = 0;
	step100=DEF_STEP100; // steps for 100 mm
	point0_x=0;
	point0_y=0;
	point0_typ=0;

}
//---------------------------------------------------------------------


void __fastcall TMDIChild::PaintBox1MouseMove(TObject *Sender,
	  TShiftState Shift, int X, int Y)
{
	int ix,iy;
	if(!dis_crosshair)
	{
		// remove old crosshair
		if(is_crosshair) DrawCrossHairs();
		CurrX=X; CurrY=Y;
		// paint new crosshair
		DrawCrossHairs();
	}
	if(is_marked)
	{
		// remove old mark
		DrawMarkShape();
		amX=X;
		amY=Y;
		// Draw new mark
		DrawMarkShape();
	}
	ix=X;
	iy=Y;
	to_real(&ix, &iy);
	StatusBar1->Panels->Items[2]->Text= "x: "+ AnsiString(ix)+" y: "+AnsiString(iy);
	StatusBar1->Panels->Items[0]->Text= "x: "+ FloatToStrF((double)ix*100/step100,ffNumber,8,2)+"mm y: "+FloatToStrF((double)iy*100/step100,ffNumber,8,2)+"mm";
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::load_plt(TPaintBox *dst, String name)
{
//	dst->Caption=name;
	area_x = area_y = area_x1 = area_y1 = 0;
	load_plt_file(name.c_str() );
	calc_zoom();
//	ScrollBar1->Max=area_x1;
//	ScrollBar2->Max=area_y1;
//	ScrollBar1->PageSize=(area_x1-area_x)/10;
//	ScrollBar2->PageSize=(area_y1-area_y)/10;
}

void i_strlw( char *text )
{
	register char *p;

	p = text;
	while(*p != 0)
	{
		*p = tolower(*p);
		p++;
	}
}

int i_strcasecmp(unsigned char *src, unsigned char *dst)
{
	register int ret = 0 ;
	while(((ret = tolower(*src) - tolower(*dst)) ==0) && (*dst))
	{
		++src, ++dst;
	}
	if ( ret < 0 )
	{
		ret = -1 ;
	}
	else if ( ret > 0 )
	{
		ret = 1 ;
	}

	return( ret );
}

int i_strncasecmp(unsigned char *src, unsigned char *dst, int num)
{
	register int ret = 0 ;
	register int i=0;

	while(i < num && ((ret = tolower(*src) - tolower(*dst)) ==0) && (*dst) )
	{
		++src, ++dst;
		i++;
	}
	if ( ret < 0 )
	{
		ret = -1 ;
	}
	else if ( ret > 0 )
	{
		ret = 1 ;
	}

	return( ret );

}

char *i_strcasestr(unsigned char *src, unsigned char *dst)
{
	register int ret = 1 ;
	unsigned char *ps,*pd;

	ps=src;
	pd=dst;

	while((*src) )
	{
		ps=src;
		pd=dst;
		while((*pd) && ((ret = tolower(*ps) - tolower(*pd)) ==0))
		{
			++ps, ++pd;
		}
		if ( ret == 0 )
		{
			return src;
		}
		++src;
	}

	return( NULL );
}

void TMDIChild::clean_plt()
{
	PLTLIST *pnext;
	CORDLIST *cnext;

	area_x = area_y = 99999999;
	area_x1 = area_y1 = -99999999;
	pnext=pltlist;
	while(pnext)
	{
		pnext->rec_x = pnext->rec_y = 99999999;
		pnext->rec_x1 = pnext->rec_y1 = -99999999;
		if(pnext->cord !=NULL &&  pnext->cord->next != NULL)
		{
			// es wird gezeichnet, also diese daten zur ermittlung der rechtecke verwenden
			// die ersten daten sind die startcoordinaten
			cnext=pnext->cord;
			while(cnext)
			{
				if(cnext->x<pnext->rec_x) pnext->rec_x=cnext->x;
				if(cnext->y<pnext->rec_y) pnext->rec_y=cnext->y;
				if(cnext->x>pnext->rec_x1) pnext->rec_x1=cnext->x;
				if(cnext->y>pnext->rec_y1) pnext->rec_y1=cnext->y;
				cnext=cnext->next;
			}
			if(pnext->rec_x<area_x) area_x=pnext->rec_x;
			if(pnext->rec_y<area_y) area_y=pnext->rec_y;
			if(pnext->rec_x1>area_x1) area_x1=pnext->rec_x1;
			if(pnext->rec_y1>area_y1) area_y1=pnext->rec_y1;
		}
		else
		{
			pnext->del=1;
		}
		pnext=pnext->next;
	}
}

#define PLT_NONE 0
#define PLT_PU 1
#define PLT_PD 2
#define PLT_PR 3
#define PLT_PA 4
#define PLT_SP 5
#define PLT_XPA 6


void __fastcall TMDIChild::draw_plt(int x, int y , int z, int a, int sp,int fl)
{
	if(fl)
	{
		if(!pltlist)
		{
			PLT_add();
		}
		PLT_add_draw(x,y,z,a,sp,pltlast);
	}
	else
	{
		PLT_add();
		PLT_add_draw(x,y,z,a,sp,pltlast);
	}
}

void TMDIChild::transform_save(int *ex, int *ey)
{
	int x,y,tmp;

	x=*ex;
	y=*ey;

	if(point0_typ)
	{
		// move 0-point
		x-=point0_x;
		y-=point0_y;
		switch(point0_typ)
		{
			case 2:
				tmp=x;
				x=y;
				y=tmp;
				x=-x;
				break;
			case 3:
				y=-y;
				x=-x;
				break;
			case 4:
				tmp=x;
				x=y;
				y=tmp;
				y=-y;
				break;
			case 5:
				x=-x;
				break;
			case 6:
				tmp=x;
				x=y;
				y=tmp;
				break;
			case 7:
				y=-y;
				break;
			case 8:
				tmp=x;
				x=y;
				y=tmp;
				y=-y;
				x=-x;
				break;
		}
	}

	x*=DEF_STEP100;
	x/=step100;
	y*=DEF_STEP100;
	y/=step100;

	*ex=x;
	*ey=y;
}

void __fastcall TMDIChild::save_plt_file(char *fname)
{
	FILE *fp;
	char buf[1024];
	PLTLIST *pnext;
	CORDLIST *cnext;
	int x,y;
	int lpen=-99;

	if((fp=fopen(fname,"w"))!=NULL)
	{
		pnext=pltlist;
		while(pnext)
		{
			if(pnext->del==false)
			{
				if(pnext->cord && pnext->cord->next)
				{
					x=pnext->cord->x;
					y=pnext->cord->y;
					transform_save(&x,&y);

					sprintf(buf,"PU;\n");
					fputs(buf,fp);

					if(lpen!=pnext->pen)
					{
						lpen=pnext->pen;
						sprintf(buf,"SP %d;\n",pnext->pen);
						fputs(buf,fp);
					}

					sprintf(buf,"PA %d,%d;\nPD;\n",x,y);
					fputs(buf,fp);

					cnext=pnext->cord->next;
					while(cnext)
					{
						x=cnext->x;
						y=cnext->y;
						transform_save(&x,&y);

						sprintf(buf,"PA %d,%d;\n",x,y);
						fputs(buf,fp);
						cnext=cnext->next;
					}
				}
			}
			pnext=pnext->next;
		}
		sprintf(buf,"PU;\nPA 0,0;\n");
		fputs(buf,fp);
		fclose(fp);
	}
}

void __fastcall TMDIChild::load_plt_file(char *fname )
{
	FILE *fp=NULL;
	size_t sz;
	int val[8];
	int x=0,y=0;
	int mod_draw=0;
	int mod_rel=0;
	int mod_neg=0;
	int active_cmd=0;
	int num_par=0;
	char buf[3200];
	char *last_cmd;
	char *p1;
	char *bufc;
	int is_xhpgl=false;

	if((fp=fopen(fname,"r"))!=NULL)
	{
		bufc=buf;
		while((sz=fread(bufc,1,sizeof(buf)/2,fp))>0)
		{
			bufc[sz]='\0';
			last_cmd=buf;
			p1=buf;
			while(*p1)
			{
				if(*p1>' ')
				{
					if(is_xhpgl==false && i_strncasecmp(p1, "xhpgl", 5)==0)
					{
						mod_rel=0;
						mod_neg=0;
						active_cmd=PLT_NONE;
						num_par=0;
						mod_draw=0;
						p1+=5;
						is_xhpgl=true;
					}
					else if(is_xhpgl==true && i_strncasecmp(p1, "pa", 2)==0)
					{
						mod_rel=0;
						mod_neg=0;
						active_cmd=PLT_XPA;
						num_par=0;
						p1+=2;
					}
					else if(is_xhpgl==false && i_strncasecmp(p1, "pa", 2)==0)
					{
						mod_rel=0;
						mod_neg=0;
						active_cmd=PLT_PA;
						num_par=0;
						p1+=2;
					}
					else if(is_xhpgl==false && i_strncasecmp(p1, "pr", 2)==0)
					{
						mod_rel=1;
						mod_neg=0;
						active_cmd=PLT_PR;
						num_par=0;
						p1+=2;
					}
					else if(is_xhpgl==false && i_strncasecmp(p1, "pu", 2)==0)
					{
						mod_draw=0;
						mod_neg=0;
						active_cmd=PLT_PU;
						num_par=0;
						p1+=2;
					}
					else if(is_xhpgl==false && i_strncasecmp(p1, "pd", 2)==0)
					{
						mod_draw=1;
						mod_neg=0;
						active_cmd=PLT_PD;
						num_par=0;
						p1+=2;
					}
					else if(is_xhpgl==false && i_strncasecmp(p1, "sp", 2)==0)
					{
						mod_neg=0;
						active_cmd=PLT_SP;
						num_par=0;
						p1+=2;
					}
					else if(is_xhpgl==false && i_strncasecmp(p1, "in", 2)==0)
					{
						mod_draw=0;
						mod_neg=0;
						active_cmd=PLT_NONE;
						num_par=0;
						draw_plt(0, 0 ,0,0,0,mod_draw); // move home-position
						p1+=2;
					}
					else if(*p1==';')
					{
						// end of command
						mod_neg=0;
						active_cmd=PLT_NONE;
						p1++;
					}
					else if(*p1==',')
					{
						// next value
						mod_neg=0;
						p1++;
					}
					else if(*p1=='-')
					{
						// next value is neg
						mod_neg=1;
						p1++;
					}
					else if(*p1>='0' && *p1<='9' )
					{
						// next value
						val[num_par]=0;
						while(*p1>='0' && *p1<='9')
						{
							val[num_par] = val[num_par]*10 + *p1 - '0';
							p1++;
						}
						while(*p1 && (*p1<=' ' || *p1==',' || *p1==';'))
						{
							// skip whitespace / val-termination
							p1++;
						}

						if(*p1)
						{
							if(mod_neg)
							{
								val[num_par]*=-1;
							}

							switch(active_cmd)
							{
								case PLT_NONE :
								break;

								case PLT_SP :
									// set_pen
									lastpen=val[0];
									last_cmd=p1;
								break;

								case PLT_PU :
								case PLT_PD :
								case PLT_PA :
								case PLT_PR :
									if(num_par>=1)
									{
										switch(active_cmd)
										{
											case PLT_PU :
												// werte eintragen
												if(mod_rel)
												{
													x+=val[0];
													y+=val[1];
												}
												else
												{
													x=val[0];
													y=val[1];
												}
												draw_plt(x, y,0,0,0,0);
												last_cmd=p1;
											break;
											case PLT_PD :
												// werte eintragen
												if(mod_rel)
												{
													x+=val[0];
													y+=val[1];
												}
												else
												{
													x=val[0];
													y=val[1];
												}
												draw_plt(x, y,0,0,0 ,1);
												last_cmd=p1;
											break;
											case PLT_PA :
												// werte eintragen
												x=val[0];
												y=val[1];
												draw_plt(x, y,0,0,0 ,mod_draw);
												last_cmd=p1;
											break;
											case PLT_PR :
												// werte eintragen
												x+=val[0];
												y+=val[1];
												draw_plt(x, y,0,0,0,mod_draw);
												last_cmd=p1;
											break;
										}
										num_par=0;
									}
									else
									{
										num_par++;
									}
								break;

								case PLT_XPA :
									if(num_par>=4)
									{
										x=val[0];
										y=val[1];

										if(val[2]>=0)
										{
											if(mod_draw==0)
											{
												// werte eintragen
												draw_plt(x, y,val[2],val[3],val[4] ,0);
											}
											else
											{
												// werte eintragen
												draw_plt(x, y,val[2],val[3],val[4] ,1);
											}
											mod_draw=1;
										}
										else
										{
											mod_draw=0;
										}
										last_cmd=p1;
									}
									else
									{
										num_par++;
									}
								break;
							}
							mod_neg=0;
						}
					}
					else
					{
						p1++;
					}
				}
				else
				{
					p1++;
				}
			}
			num_par=0;
			sz=strlen(last_cmd);
			memcpy(buf,last_cmd,sz+1);
			bufc=buf+sz;
		}
		clean_plt();
	}
}

void TMDIChild::DrawMarkShape()
{
	// remember current pen and brush
	TPen *oldPen = new TPen;
	oldPen->Assign(PaintBox1->Canvas->Pen);

	TBrush *oldBrush = new TBrush;
	oldBrush->Assign(PaintBox1->Canvas->Brush);

	// create xornot dotted pen and clear brush
	TPen *newPen = new TPen;
	newPen->Mode = pmNotXor;
	newPen->Style = psDot;
	PaintBox1->Canvas->Pen->Assign(newPen);

	TBrush *newBrush = new TBrush;
	newBrush->Style = bsClear;
	PaintBox1->Canvas->Brush->Assign(newBrush);

	// draw shape
	PaintBox1->Canvas->Rectangle(smX, smY,amX, amY);

	// reset current pen and brush
	PaintBox1->Canvas->Pen->Assign(oldPen);
	PaintBox1->Canvas->Brush->Assign(oldBrush);
	delete oldPen;
	delete newPen;
	delete oldBrush;
	delete newBrush;
	is_marked=true;
}

void TMDIChild::rmCrossHairs(void)
{
	if(is_crosshair)
	{
		// remove crosshair
		DrawCrossHairs();
		is_crosshair=0;
	}
}

void TMDIChild::DrawCrossHairs()
{
	if(dis_crosshair==false)
	{
		// remember current pen
		TPen *oldPen = new TPen;
		oldPen->Assign(PaintBox1->Canvas->Pen);

		// set xornot pen
		TPen *newPen = new TPen;
		newPen->Mode = pmNotXor;
		PaintBox1->Canvas->Pen->Assign(newPen);

		// draw two lines
		PaintBox1->Canvas->MoveTo(0, CurrY);
		PaintBox1->Canvas->LineTo(PaintBox1->Width, CurrY);
		PaintBox1->Canvas->MoveTo(CurrX, 0);
		PaintBox1->Canvas->LineTo(CurrX, PaintBox1->Height);

		// reset current pen
		PaintBox1->Canvas->Pen->Assign(oldPen);
		is_crosshair=1;
		delete oldPen; delete newPen;
	}
}

void __fastcall TMDIChild::FormShow(TObject *Sender)
{
	PaintBox1->Cursor = crNone;

}
//---------------------------------------------------------------------------

void TMDIChild::ST_add(int x, int y)
{
	STLIST *next;

	next = (STLIST *)malloc(sizeof(STLIST));
	if(next)
	{
		next->x=x;
		next->y=y;
		next->next=stlist;
		stlist=next;
	}
}

void TMDIChild::ST_rm(int x, int y)
{
	STLIST *stnext;
	STLIST *stprev;

	stnext = stlist;
	stprev=NULL;
	while(stnext)
	{
		if(x > stnext->x-40 && x < stnext->x+40 && y > stnext->y-40 && y < stnext->y+40)
		{
			if(stprev==NULL)
			{
				stlist=stlist->next;
			}
			else
			{
				stprev->next=stnext->next;
			}
			free(stnext);
			break;
		}
		stprev=stnext;
		stnext=stnext->next;
	}
}

void TMDIChild::PLT_add(void)
{
	PLTLIST *next;

	next = (PLTLIST *)malloc(sizeof(PLTLIST));
	if(next)
	{
		next->next=NULL;
		next->cord=NULL;
		next->cordl=NULL;
		next->rec_x=0;
		next->rec_y=0;
		next->rec_x1=0;
		next->rec_y1=0;
		next->del=0;
		next->mark=0;
		next->pen=lastpen;
		if(!pltlast)
		{
			pltlist=next;
		}
		else
		{
			pltlast->next=next;
		}
		pltlast=next;
	}
}

void TMDIChild::PLT_add_draw(int x, int y, int z, int a, int sp, PLTLIST *cur)
{
	CORDLIST *next;
	if(cur)
	{
		next = (CORDLIST *)malloc(sizeof(CORDLIST));
		if(next)
		{
			next->next=NULL;
			next->prev=cur->cordl;
			next->x=x;
			next->y=y;
			next->z=z;
			next->a=a;
			next->sp=sp;


			// remember outlines
			if(x>cur->rec_x1)
			{
				cur->rec_x1=x;
			}
			if(x<cur->rec_x)
			{
				cur->rec_x=x;
			}
			if(y>cur->rec_y1)
			{
				cur->rec_y1=y;
			}
			if(y<cur->rec_y)
			{
				cur->rec_y=y;
			}

			if(!cur->cordl)
			{
				cur->cord=next;
			}
			else
			{
				cur->cordl->next=next;
			}
			cur->cordl=next;
		}
	}
}


void __fastcall TMDIChild::FormDestroy(TObject *Sender)
{
	// cleanup plot-list
	CORDLIST *cnext;
	PLTLIST *pnext;
	STLIST *stnext;

	while(pltlist)
	{
		pnext=pltlist->next;
		while(pltlist->cord)
		{
			cnext= pltlist->cord->next;
			free(pltlist->cord);
			pltlist->cord=cnext;
		}
		free(pltlist);
		pltlist=pnext;
	}
	pltlast=NULL;

	// clear steg-liste
	while(stlist)
	{
		stnext=stlist->next;
		free(stlist);
		stlist=stnext;
	}

}
//---------------------------------------------------------------------------



void __fastcall TMDIChild::ScrollBar1Scroll(TObject *Sender,
	  TScrollCode ScrollCode, int &ScrollPos)
{
	rmCrossHairs();
	dis_crosshair=true;
	PaintBox1->Repaint();
	dis_crosshair=false;
}
//---------------------------------------------------------------------------



void __fastcall TMDIChild::ScrollBar2Scroll(TObject *Sender,
	  TScrollCode ScrollCode, int &ScrollPos)
{
	rmCrossHairs();
	dis_crosshair=true;
	PaintBox1->Repaint();
	dis_crosshair=false;

}
//---------------------------------------------------------------------------

void TMDIChild::calc_zoom(void)
{
	double oldp;
	int max;

	ScrollBar1->Enabled=false;
	ScrollBar2->Enabled=false;

	max=(area_x1-area_x);
	ScrollBar1->Max=max;

	if(((double) max*zoom) > PaintBox1->Width)
	{
		ScrollBar1->PageSize=(double)PaintBox1->Width/zoom;
	}
	else
	{
		ScrollBar1->PageSize=max;
		ScrollBar1->Position=0;
	}

	max=(area_y1-area_y);
	ScrollBar2->Max=max;

	if(((double) max*zoom) > PaintBox1->Height)
	{
		ScrollBar2->PageSize=(double)PaintBox1->Height/zoom;
	}
	else
	{
		ScrollBar2->PageSize=max;
		ScrollBar2->Position=0;
	}

	ScrollBar1->Enabled=true;
	ScrollBar2->Enabled=true;
}

void __fastcall TMDIChild::FormMouseWheel(TObject *Sender, TShiftState Shift,
	  int WheelDelta, TPoint &MousePos, bool &Handled)
{
	int do_zoom=0;

	// zoom
	if(WheelDelta >0)
	{
		if(zoom <10.0)
		{
			zoom*=1.1;
			do_zoom=1;
		}
	}
	else
	{
		if(zoom >0.001)
		{
			zoom/=1.1;
			do_zoom=1;
		}
	}

	if(do_zoom)
	{
		if(PaintBox2->Visible==true)
		{
			Edit1->Text=AnsiString((double)PaintBox2->Width*100/zoom/step100);
		}
		rmCrossHairs();
		dis_crosshair=1;
		calc_zoom();
		PaintBox1->Repaint();
		dis_crosshair=0;
	}
}
//---------------------------------------------------------------------------

void TMDIChild::transform(int *ex, int *ey)
{
	int x,y;
	// transform to 0
	x=*ex-area_x;
	y=*ey-area_y;

	// use scrollbar
	x-=ScrollBar1->Position;
	y-=ScrollBar2->Max-ScrollBar2->Position;

	// zoom
	x*=zoom;
	y*=zoom;

	// transform 0 to bottom
//	y-=PaintBox1->Height;
	*ex=x;
	*ey=y;
}

void TMDIChild::to_real(int *ex, int *ey)
{
	int x,y;

	x=(double)(*ex+1)/zoom;
	y=-((double)(*ey+1)/zoom);

	x+= ScrollBar1->Position;
	y+= ScrollBar2->Max-ScrollBar2->Position;

	x+=area_x;
	y+=area_y;

	*ex=x;
	*ey=y;
}

void TMDIChild::PaintMark(int x, int y)
{
	TPoint points[4];
	TColor oldc= PaintBox1->Canvas->Brush->Color;

	SetMapMode(PaintBox1->Canvas->Handle, MM_ANISOTROPIC);
	SetWindowExtEx(PaintBox1->Canvas->Handle, PaintBox1->Width, PaintBox1->Height, NULL);
	SetViewportExtEx(PaintBox1->Canvas->Handle, PaintBox1->Width, -PaintBox1->Height, NULL);

	PaintBox1->Canvas->Pen->Color = (TColor)RGB(0, 0, 255);

	PaintBox1->Canvas->MoveTo(  x-10,  y-10);
	PaintBox1->Canvas->LineTo(  x+11,  y+11);
	PaintBox1->Canvas->MoveTo(  x-10,  y+10);
	PaintBox1->Canvas->LineTo(  x+11,  y-11);

	PaintBox1->Canvas->Brush->Color = oldc;
}

void TMDIChild::PaintPoint0_line(int x, int y, int lx, int ly)
{
	TPoint points[4];
	TColor oldc= PaintBox1->Canvas->Brush->Color;
	int pf=-8;

	PaintBox1->Canvas->Brush->Color = (TColor)RGB(0, 0, 255);

	if(lx==0)
	{
		if(ly<0) pf=8;
		points[0] = Point(x-3,y+ly+pf);
		points[1] = Point(x,y+ly);
		points[2] = Point(x+3,y+ly+pf);
		points[3] = Point(x-3,y+ly+pf);
		PaintBox1->Canvas->Polygon(points, 3);
		PaintBox1->Canvas->MoveTo(  x,  y);
		PaintBox1->Canvas->LineTo(  x,  y+ly);
	}
	else
	{
		if(lx<0) pf=8;
		points[0] = Point(  x+lx+pf,  y+3);
		points[1] = Point(  x+lx,  y);
		points[2] = Point(  x+lx+pf,  y-3);
		points[3] = Point(  x+lx+pf,  y+3);
		PaintBox1->Canvas->Polygon(points, 3);
		PaintBox1->Canvas->MoveTo(  x,  y);
		PaintBox1->Canvas->LineTo(  x+lx,  y);
	}
	PaintBox1->Canvas->Brush->Color = oldc;
}

void TMDIChild::PaintPoint0(void)
{
	int x,y;
	TPoint points[4];

	if(point0_typ)
	{
		x=point0_x;
		y=point0_y;
		transform(&x, &y);

		PaintBox1->Canvas->Pen->Color = (TColor)RGB(0, 0, 255);
		PaintBox1->Canvas->Font->Color = (TColor)RGB(0, 0, 255);

		switch(point0_typ)
		{
			case 1:
				PaintPoint0_line(x, y, 50, 0);
				PaintPoint0_line(x, y, 0, 50);
				PaintBox1->Canvas->TextOutA(x-10,y-2,AnsiString("0,0"));
				PaintBox1->Canvas->TextOutA(x-4,y+66,AnsiString("y+"));
				PaintBox1->Canvas->TextOutA(x+54,y+8,AnsiString("x+"));
				break;
			case 2:
				PaintPoint0_line(x, y, 50, 0);
				PaintPoint0_line(x, y, 0, -50);
				PaintBox1->Canvas->TextOutA(x-10,y+15,AnsiString("0,0"));
				PaintBox1->Canvas->TextOutA(x+4,y-56,AnsiString("x+"));
				PaintBox1->Canvas->TextOutA(x+54,y+8,AnsiString("y+"));
				break;
			case 3:
				PaintPoint0_line(x, y, -50, 0);
				PaintPoint0_line(x, y, 0, -50);
				PaintBox1->Canvas->TextOutA(x-10,y+15,AnsiString("0,0"));
				PaintBox1->Canvas->TextOutA(x+4,y-56,AnsiString("y+"));
				PaintBox1->Canvas->TextOutA(x-76,y+8,AnsiString("x+"));
				break;
			case 4:
				PaintPoint0_line(x, y, -50, 0);
				PaintPoint0_line(x, y, 0, 50);
				PaintBox1->Canvas->TextOutA(x-10,y-2,AnsiString("0,0"));
				PaintBox1->Canvas->TextOutA(x-4,y+66,AnsiString("x+"));
				PaintBox1->Canvas->TextOutA(x-76,y+8,AnsiString("y+"));
				break;
			case 5:
				PaintPoint0_line(x, y, 0, 50);
				PaintBox1->Canvas->Pen->Color = (TColor)RGB(255, 0, 0);
				PaintPoint0_line(x, y, -50, 0);
				PaintBox1->Canvas->TextOutA(x-10,y-2,AnsiString("0,0"));
				PaintBox1->Canvas->TextOutA(x-4,y+66,AnsiString("y+"));
				PaintBox1->Canvas->TextOutA(x-76,y+8,AnsiString("x+"));
				break;
			case 6:
				PaintPoint0_line(x, y, 50, 0);
				PaintBox1->Canvas->Pen->Color = (TColor)RGB(255, 0, 0);
				PaintPoint0_line(x, y, 0, 50);
				PaintBox1->Canvas->TextOutA(x-10,y-2,AnsiString("0,0"));
				PaintBox1->Canvas->TextOutA(x-4,y+66,AnsiString("x+"));
				PaintBox1->Canvas->TextOutA(x+54,y+8,AnsiString("y+"));
				break;
			case 7:
				PaintPoint0_line(x, y, 0, -50);
				PaintBox1->Canvas->Pen->Color = (TColor)RGB(255, 0, 0);
				PaintPoint0_line(x, y, 50, 0);
				PaintBox1->Canvas->TextOutA(x-10,y+15,AnsiString("0,0"));
				PaintBox1->Canvas->TextOutA(x+4,y-56,AnsiString("y+"));
				PaintBox1->Canvas->TextOutA(x+54,y+8,AnsiString("x+"));
				break;
			case 8:
				PaintPoint0_line(x, y, -50, 0);
				PaintBox1->Canvas->Pen->Color = (TColor)RGB(255, 0, 0);
				PaintPoint0_line(x, y, 0, -50);
				PaintBox1->Canvas->TextOutA(x-10,y+15,AnsiString("0,0"));
				PaintBox1->Canvas->TextOutA(x+4,y-56,AnsiString("x+"));
				PaintBox1->Canvas->TextOutA(x-76,y+8,AnsiString("y+"));
				break;
		}

	}
}

boolean test_pos(int x , int y, int *x1, int *y1)
{
	if(x > (*x1)-5 && x < (*x1)+5 && y > (*y1)-5 && y < (*y1)+5)
	{
		*x1=x;
		*y1=y;
		return true;
	}
	return false;
}

void TMDIChild::PaintSTList(STLIST * stnext)
{
	int x,y,x1,y1;

	if(stnext)
	{
		x=stnext->x-40;
		y=stnext->y-40;
		x1=stnext->x+40;
		y1=stnext->y+40;
		transform(&x, &y);
		transform(&x1, &y1);
		PaintBox1->Canvas->Ellipse (x, y, x1, y1);
	}
}
//---------------------------------------------------------------------------

void TMDIChild::PaintPLTList(PLTLIST * pnext)
{
	CORDLIST *cnext;
	bool cfirst;
	int x,y;

	if(pnext)
	{
		cnext=pnext->cord;
		cfirst=false;

		if(pnext->del==0)
		{
			while(cnext)
			{
				x=cnext->x;
				y=cnext->y;
				transform(&x, &y);

				if(cfirst)
				{
					PaintBox1->Canvas->LineTo(  x,  y);
				}
				else
				{
					PaintBox1->Canvas->MoveTo(  x,  y);
					cfirst=true;
				}
				cnext=cnext->next;
			}
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::PaintBox1Paint(TObject *Sender)
{
	STLIST *stnext;
	PLTLIST *pnext;
	CORDLIST *cnext;
	int cfirst;
	int x,y;

	rmCrossHairs();
	dis_crosshair=true;

	SetMapMode(PaintBox1->Canvas->Handle, MM_ANISOTROPIC);
	SetWindowExtEx(PaintBox1->Canvas->Handle, PaintBox1->Width, PaintBox1->Height, NULL);
	SetViewportExtEx(PaintBox1->Canvas->Handle, PaintBox1->Width, -PaintBox1->Height, NULL);

	pnext=pltlist;
	while(pnext)
	{
		if(pnext->mark)
		{
			PaintBox1->Canvas->Pen->Color = (TColor)RGB(255, 0, 0);
		}
		else
		{
			PaintBox1->Canvas->Pen->Color = (TColor) RGB(0, 0, 0);
		}

		PaintPLTList(pnext);
		pnext=pnext->next;
	}

	PaintBox1->Canvas->Pen->Color = (TColor)RGB(255, 0, 0);
	stnext=stlist;
	while(stnext)
	{
		PaintSTList(stnext);
		stnext=stnext->next;
	}

	PaintPoint0();

	dis_crosshair=false;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ToolButton1Click(TObject *Sender)
{
	double zfx;
	double zfy;

	zfx=(double)PaintBox1->Width/(area_x1-area_x);
	zfy=(double)PaintBox1->Height/(area_y1-area_y);
	if(zfx>zfy)
	{
		zoom=zfy;
	}
	else
	{
		zoom=zfx;
	}
	ScrollBar1->Position=0;
	ScrollBar2->Position=0;
	calc_zoom();
	Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ToolButton6Click(TObject *Sender)
{
	zoom=(double)PaintBox1->Width/(area_x1-area_x);
	ScrollBar1->Position=0;
	ScrollBar2->Position=0;
	calc_zoom();
	Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ToolButton7Click(TObject *Sender)
{
	zoom=(double)PaintBox1->Height/(area_y1-area_y);
	ScrollBar1->Position=0;
	ScrollBar2->Position=0;
	calc_zoom();
	Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::PaintBox1MouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if(is_marked)
	{
		DrawMarkShape();
		is_marked=false;
	}

	smShift=0;
	if(Shift.Contains(ssShift) && Shift.Contains(ssCtrl))
	{
		smShift=1;
	}
	else if(Shift.Contains(ssCtrl))
	{
		smShift=2;
	}
	else if(Shift.Contains(ssShift))
	{
		smShift=3;
	}
	else if(Shift.Contains(ssAlt))
	{
		smShift=4;
	}

	smX=X;
	smY=Y;
	amX=X;
	amY=Y;
	DrawMarkShape();
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::PaintBox1MouseUp(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	PLTLIST *pnext;
	int ex,ey,ex1,ey1;

	if(is_marked)
	{
		// remove marking
		DrawMarkShape();
		is_marked=false;

		// mark the lines
		ex=smX-XY_MARK_OFF;
		ey=smY-XY_MARK_OFF;
		ex1=amX+XY_MARK_OFF;
		ey1=amY+XY_MARK_OFF;

		to_real(&ex, &ey);
		to_real(&ex1, &ey1);

		pnext=pltlist;
		while(pnext)
		{
			if( min(ex,ex1) < pnext->rec_x
			 && max(ex,ex1) > pnext->rec_x1
			 && min(ey,ey1) < pnext->rec_y
			 && max(ey,ey1) > pnext->rec_y1)
			{
				if(Shift.Contains(ssShift) && Shift.Contains(ssCtrl))
				{
					pnext->del=false;
					pnext->mark=false;
				}
				else if(Shift.Contains(ssCtrl))
				{
					pnext->del=true;
					pnext->mark=false;
				}
				else if(Shift.Contains(ssShift))
				{
					pnext->mark=false;
				}
				else if(pnext->del == false)
				{
					pnext->mark=true;
				}
			}
			pnext=pnext->next;
		}

		rmCrossHairs();
		Repaint();
	}
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::PaintBox1MouseLeave(TObject *Sender)
{
	rmCrossHairs();
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::FormPaint(TObject *Sender)
{
	rmCrossHairs();
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ToolButton10Click(TObject *Sender)
{
	PLTLIST *pnext;

	pnext=pltlist;
	while(pnext)
	{
		if( pnext->mark==true)
		{
			pnext->del=true;
			pnext->mark=false;
		}
		pnext=pnext->next;
	}

	rmCrossHairs();
	Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::ToolButton15Click(TObject *Sender)
{
	PLTLIST *pnext;

	pnext=pltlist;
	while(pnext)
	{
		if( pnext->mark==true)
		{
			pnext->mark=false;
		}
		pnext=pnext->next;
	}

	rmCrossHairs();
	Repaint();

}
//---------------------------------------------------------------------------




void __fastcall TMDIChild::FormKeyDown(TObject *Sender, WORD &Key,
	  TShiftState Shift)
{
	int ex,ey;

	if(Shift.Contains(ssShift) && Shift.Contains(ssCtrl))
	{
		StatusBar1->Panels->Items[3]->Text="undelete region";
	}
	else if(Shift.Contains(ssCtrl))
	{
		StatusBar1->Panels->Items[3]->Text="delete region";
	}
	else if(Shift.Contains(ssShift))
	{
		StatusBar1->Panels->Items[3]->Text="unmark region / unmark";
	}
	else if(Shift.Contains(ssAlt))
	{
		StatusBar1->Panels->Items[3]->Text="set 0-point";
	}
	else
	{
//		StatusBar1->Panels->Items[3]->Text="mark region / mark";
	}
//	else
//	{
//		StatusBar1->Panels->Items[3]->Text="";
//	}

	switch (Key)
	{
		case VK_DELETE:
			ToolButton10Click(Sender);
			break;

		case VK_ESCAPE:
			ToolButton15Click(Sender);
			break;

		case VK_LEFT:
			if(ScrollBar1->Position > ScrollBar1->LargeChange)
			{
				ScrollBar1->Position-=ScrollBar1->LargeChange;
				calc_zoom();
				Repaint();
			}
			else if(ScrollBar1->Position > 0)
			{
				ScrollBar1->Position=0;
				calc_zoom();
				Repaint();
			}
			break;

		case VK_RIGHT:
			if(ScrollBar1->Position < (ScrollBar1->Max-ScrollBar1->PageSize))
			{
				ScrollBar1->Position+=ScrollBar1->LargeChange;
				calc_zoom();
				Repaint();
			}
			break;

		case VK_DOWN:
			if(ScrollBar2->Position < (ScrollBar2->Max-ScrollBar2->PageSize))
			{
				ScrollBar2->Position+=ScrollBar2->LargeChange;
				calc_zoom();
				Repaint();
			}
			break;

		case VK_UP:
			if(ScrollBar2->Position > ScrollBar2->LargeChange)
			{
				ScrollBar2->Position-=ScrollBar2->LargeChange;
				calc_zoom();
				Repaint();
			}
			else if(ScrollBar2->Position > 0)
			{
				ScrollBar2->Position=0;
				calc_zoom();
				Repaint();
			}
			break;

		case VK_NEXT:
			FormMouseWheel(Sender, Shift, -1, Point(0,0), NULL);
			break;

		case VK_PRIOR:
			FormMouseWheel(Sender, Shift, 1, Point(0,0), NULL);
			break;

		case VK_F2:
			if(point0_typ)
			{
				point0_typ++;
				if(point0_typ>8)
				{
					point0_typ=1;
				}
				rmCrossHairs();
				Repaint();
			}
			break;

		case 'S':
			rmCrossHairs();
			ex=CurrX; ey=CurrY;
			to_real(&ex, &ey);
//			if(find_linepoint_list(&ex, &ey))
			if(find_lpoint(&ex, &ey))

			{
				ST_add(ex, ey);
				Repaint();
			}
			break;

		case 'R':
			rmCrossHairs();
			ex=CurrX; ey=CurrY;
			to_real(&ex, &ey);
			ST_rm(ex, ey);
			Repaint();
			break;

		case VK_HOME:
		case VK_END:
			break;
	  }

}
//---------------------------------------------------------------------------

boolean TMDIChild::split_line(int x, int y, int width, int x1, int y1, int x2, int y2, int *xa, int *ya, int *xb, int *yb)
{
	int x3,y3;
	int px,py,px1,py1;
	double ax;

	x3=x;
	y3=y;

	// ist der angegebene punkt (x,y) auf der linie?
	if(find_lpoint_pos(x1, y1, x2, y2, 1, &x3, &y3))
	{
		if(x1==x2)
		{
			// keine nderung x-achse; nur auf der y-achse wird unterbrochen
			*xa=x1;
			*xb=x1;
			if(y1<y2)
			{
				*ya=y3-width/2;
				*yb=y3+width/2;
			}
			else
			{
				*ya=y3+width/2;
				*yb=y3-width/2;
			}
		}
		else if(y1==y2)
		{
			// keine nderung y-achse; nur auf der x-achse wird unterbrochen
			*ya=y1;
			*yb=y1;
			if(x1<x2)
			{
				*xa=x3-width/2;
				*xb=x3+width/2;
			}
			else
			{
				*xa=x3+width/2;
				*xb=x3-width/2;
			}
		}
		else
		{
			// der punkt ist auf der linie, errechne die linienunterbrechungen
			ax=atan2((x1-x2),(y1-y2));

			// dies ist der 2. punkt (x1,y1 ist der 1.; x2,y2 ist der 4.)
			*xa=x3+(double)(width/2)*sin(ax);
			*ya=y3+(double)(width/2)*cos(ax);
			// dies ist der 3. punkt (x1,y1 ist der 1.; x2,y2 ist der 4.)
			*xb=x3-(double)(width/2)*sin(ax);
			*yb=y3-(double)(width/2)*cos(ax);
		}
		return true;
	}
	return false;
}


boolean TMDIChild::find_lpoint_pos(int x1, int y1, int x2, int y2, int snap, int *x3, int *y3)
{
	int xx,xy;
	int px,py,px1,py1;
	int dx,dy;
	double vx;
	double ax;

	xx=*x3; xy=*y3;

	px=x1; px1=x2;
	py=y1; py1=y2;
	if(x1>x2)
	{
		px=x2;
		px1=x1;
	}
	if(y1>y2)
	{
		py=y2;
		py1=y1;
	}

	// ist diese linie im bereich der coordinaten?
	if(xx > px-snap && xx < px1+snap && xy > py-snap && xy < py1+snap)
	{
		dx=px-px1;
		dy=py-py1;

		if(dx==0 || dy==0)
		{
			// keine nderung in x oder y
			if(dy==0)
			{
				if(xx>px && xx <px1)
				{
					// keine nderung in y und x im bereich
					*x3=xx; *y3=py;
//StatusBar1->Panels->Items[3]->Text= "x: "+ AnsiString(xx)+" y: "+AnsiString(py);
					return true;
				}
			}
			else
			{
				if(xy>py && xy <py1)
				{
					// keine nderung in x und y im bereich
					*x3=px; *y3=xy;
//StatusBar1->Panels->Items[3]->Text= "x: "+ AnsiString(px)+" y: "+AnsiString(xy);
					return true;
				}
			}
		}
		else
		{
			vx=(double)(x1-x2)/(double)(y1-y2);
			// hier mu berechnet werden
			dx=((double)(xy-y1)*vx)+x1;
			dy=((double)(xx-x1)/vx)+y1;
			if(xx>dx-10 && xx < dx+10 && xy>dy-10 && xy<dy+10)
			{
				*x3=dx; *y3=xy;
#ifdef ttt
dy=xy;
ax=atan2((x1-x2),(y1-y2));

StatusBar1->Panels->Items[3]->Text= "x: "+ AnsiString(dx)+" y: "+AnsiString(dy)+" ax: "+AnsiString(ax*BM)+" x1: "+AnsiString((double)160.0*cos(ax))+" y1: "+AnsiString((double)160.0*sin(ax));

px=x1; py=y1;
transform(&px,&py);
PaintMark(px, py);
PaintBox1->Canvas->TextOutA(px,py,AnsiString("1"));

px=x2; py=y2;
transform(&px,&py);
PaintMark(px, py);
PaintBox1->Canvas->TextOutA(px,py,AnsiString("4"));

px=dx+80.0*sin(ax);
py=dy+80.0*cos(ax);
transform(&px,&py);
PaintMark(px, py);
PaintBox1->Canvas->TextOutA(px,py,AnsiString("2"));

px=dx-80.0*sin(ax);
py=dy-80.0*cos(ax);
transform(&px,&py);
PaintMark(px, py);
PaintBox1->Canvas->TextOutA(px,py,AnsiString("3"));

transform(&dx,&dy);
PaintMark(dx, dy);
				return false;
#endif

				return true;
			}
		}
	}
	return false;
}


boolean TMDIChild::find_lpoint(int *x3, int *y3)
{
	CORDLIST *cnext;
	PLTLIST *pnext;
	int snap=10;
	int fx,fy;
	int ex,ey,ex1,ey1;
	int xx,xy;
	int px,py,px1,py1;
	int dx,dy;
	double vx,vy;
	double ax,ay;

	xx=*x3; xy=*y3;

	pnext=pltlist;
	while(pnext)
	{
		if(pnext->cord)
		{
			fx=pnext->cord->x;
			fy=pnext->cord->y;
			cnext=pnext->cord->next;
			while(cnext)
			{
				if(find_lpoint_pos(fx,fy,cnext->x,cnext->y,snap,x3,y3))
				{
					return true;
				}
				fx=cnext->x;
				fy=cnext->y;
				cnext=cnext->next;
			}
		}
		pnext=pnext->next;
	}
	return false;
}

void __fastcall TMDIChild::PaintBox1Click(TObject *Sender)
{
	PLTLIST *pnext;
	CORDLIST *cnext;
	CORDLIST *clast;
	int ex,ey,ex1,ey1,is_smark;

	is_smark=false;

	ex=smX;
	ey=smY;
	to_real(&ex, &ey);

	if(smShift==4) // Alt gedrckt
	{
		// definieren des 0-Punktes
		point0_x=ex;
		point0_y=ey;
		point0_typ=1;
		if(is_crosshair)
		{
			// remove crosshair
			DrawCrossHairs();
			is_crosshair=false;
		}
		return;
	}

	ex1=ex+(XY_CLICK_OFF/zoom);
	ey1=ey+(XY_CLICK_OFF/zoom);
	ex-=XY_CLICK_OFF/zoom;
	ey-=XY_CLICK_OFF/zoom;


	pnext=pltlist;
	while(pnext)
	{
		cnext=pnext->cord;
		clast=NULL;

		if(pnext->del==false && pnext->mark==false&& smShift==0)
		{
			while(cnext)
			{
				if( ex <= cnext->x && ex1 >= cnext->x && ey <= cnext->y && ey1 >= cnext->y)
				{
					pnext->mark=true;
					is_smark=true;
					break;
				}
				if(clast)
				{
					if(clast->x==cnext->x && ex <= cnext->x && ex1 >= cnext->x && min(clast->y,cnext->y) < ey &&  max(clast->y,cnext->y) > ey )
					{
						pnext->mark=true;
						is_smark=true;
						break;
					}
					if(clast->y==cnext->y && ey <= cnext->y && ey1 >= cnext->y && min(clast->x,cnext->x) < ex &&  max(clast->x,cnext->x) > ex )
					{
						pnext->mark=true;
						is_smark=true;
						break;
					}
				}
				clast=cnext;
				cnext=cnext->next;
			}
		}
		else if(pnext->del==false && pnext->mark==true && smShift==3)
		{
			while(cnext)
			{
				if( ex <= cnext->x && ex1 >= cnext->x && ey <= cnext->y && ey1 >= cnext->y)
				{
					pnext->mark=false;
					is_smark=true;
					break;
				}
				if(clast)
				{
					if(clast->x==cnext->x && ex <= cnext->x && ex1 >= cnext->x && min(clast->y,cnext->y) < ey &&  max(clast->y,cnext->y) > ey )
					{
						pnext->mark=false;
						is_smark=true;
						break;
					}
					if(clast->y==cnext->y && ey <= cnext->y && ey1 >= cnext->y && min(clast->x,cnext->x) < ex &&  max(clast->x,cnext->x) > ex )
					{
						pnext->mark=false;
						is_smark=true;
						break;
					}
				}
				clast=cnext;
				cnext=cnext->next;
			}
		}

		if(is_smark==true)
		{
			break;
		}
		pnext=pnext->next;
	}

	if(is_smark)
	{
		rmCrossHairs();
//		Repaint();
	}
}
//---------------------------------------------------------------------------


void __fastcall TMDIChild::ToolButton2Click(TObject *Sender)
{
	if(Panel1->Visible==false)
	{
		Panel1->Visible=true;
		PaintBox2->Visible=true;
	}
	else
	{
		Panel1->Visible= false;
		PaintBox2->Visible=false;
	}
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::FormCreate(TObject *Sender)
{
	Panel1->Visible=false;
	StatusBar1->Panels->Items[1]->Text= "Steps / 100mm: "+ AnsiString(step100);
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::PaintBox2Paint(TObject *Sender)
{
	PaintBox2->Canvas->Pen->Color = (TColor)RGB(0, 255, 0);
	PaintBox2->Canvas->MoveTo(  0,  0);
	PaintBox2->Canvas->LineTo(  0,  PaintBox2->Height-1);
	PaintBox2->Canvas->MoveTo(  PaintBox2->Width-1,  0);
	PaintBox2->Canvas->LineTo(  PaintBox2->Width-1,  PaintBox2->Height-1);
	PaintBox2->Canvas->MoveTo(  0,  PaintBox2->Height/2);
	PaintBox2->Canvas->LineTo(  PaintBox2->Width-1,  PaintBox2->Height/2);
}
//---------------------------------------------------------------------------


void __fastcall TMDIChild::PaintBox2MouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	is_mess_down=true;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::PaintBox2MouseUp(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	is_mess_down=false;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::PaintBox2MouseMove(TObject *Sender,
	  TShiftState Shift, int X, int Y)
{
	if(is_mess_down)
	{
		if(X>(PaintBox2->Width/5*4))
		{
			PaintBox2->Width=X+1;
			Edit1->Text=AnsiString((double)PaintBox2->Width*100/zoom/step100);
		}
		else
		{
			PaintBox2->Left+=X;
			PaintBox2->Top+=Y;
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::Button1Click(TObject *Sender)
{
	double val;


	val=atof(Edit1->Text.c_str());
	if(val!=0.0)
	{
		step100=(double)PaintBox2->Width*100/zoom/val;
		StatusBar1->Panels->Items[1]->Text= "Steps / 100mm: "+ AnsiString(step100);
	}
	Panel1->Visible= false;
	PaintBox2->Visible=false;
}
//---------------------------------------------------------------------------


void __fastcall TMDIChild::ToolButton3Click(TObject *Sender)
{
	PLTLIST *pnext;

	pnext=pltlist;
	while(pnext)
	{
		if( pnext->mark==true)
		{
			pnext->mark=false;
		}
		else
		{
			pnext->mark=true;
		}
		pnext=pnext->next;
	}

	rmCrossHairs();
	Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::FormKeyUp(TObject *Sender, WORD &Key,
	  TShiftState Shift)
{
//	StatusBar1->Panels->Items[3]->Text="mark region / mark";
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::FormActivate(TObject *Sender)
{
//	MainForm->ActiveMDIChild = this;
	MainForm->FileSave1->Enabled=true;
	MainForm->RS232->Enabled=true;
	MainForm->XHPGL->Enabled=true;
//	->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::FormDeactivate(TObject *Sender)
{
	MainForm->FileSave1->Enabled=false;
	MainForm->RS232->Enabled=false;
	MainForm->XHPGL->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TMDIChild::FormClose(TObject *Sender, TCloseAction &Action)
{
	Action = caFree;
	MainForm->FileSave1->Enabled=true;
	MainForm->RS232->Enabled=true;
}
//---------------------------------------------------------------------

void __fastcall TMDIChild::SaveExecute(TObject *Sender)
{
	if(SaveDialog1->FileName=="")
	{
		SaveDialog1->FileName="_"+Caption.Delete(1, Caption.LastDelimiter("\\"));
	}
	if (SaveDialog1->Execute())
	{
		save_plt_file(SaveDialog1->FileName.c_str());
	}
}
//---------------------------------------------------------------------------


void __fastcall TMDIChild::ToolButton4Click(TObject *Sender)
{
	PLTLIST *pnext;
	PLTLIST *lp;

	pnext=pltlist;
	lp=NULL;
	while(pnext)
	{
		if( pnext->mark==true)
		{
			pnext->mark=false;
			if(lp!=NULL)
			{
				// nur nach oben schieben wenn es nicht schon oben ist
				// der vorgnger bekommt den zeiger auf den aktuellen nachfolger als nachfolger
				// damit ist der aktuelle eintrag aus der liste entfernt
				lp->next=pnext->next;
				// ist der aktuelle eintrag der letzte, dann ist nun der vorgnger
				// der letzte eintrag
				if(pnext==pltlast)
				{
					pltlast=lp;
				}
				// vorne einfgen
				pnext->next=pltlist;
				pltlist=pnext;

				// der vorgnger bleibt erhalten der neue nachfahre ist der nchste
				// nach dem vorgnger
				pnext=lp->next;
			}
			else
			{
				lp=pnext;
				pnext=pnext->next;
			}
		}
		else
		{
			lp=pnext;
			pnext=pnext->next;
		}
	}

	rmCrossHairs();
	Repaint();
}
//---------------------------------------------------------------------------

