//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "serial_send.h"
#include "ChildWin.h"
#include <process.h>

#pragma argsused
USEUNIT("Tserial_event.cpp");

Tserial_event serial_port;
bool tx_busy;

/* ======================================================== */
/* ===============  OnCharArrival     ===================== */
/* ======================================================== */
void OnDataArrival(int size, char *buffer)
{
	if ((size>0) && (buffer!=0))
	{
		buffer[size] = 0;
//		printf("OnDataArrival: %s ",buffer);
	}
}

/* ======================================================== */
/* ===============  OnCharArrival     ===================== */
/* ======================================================== */
void SerialEventManager(uint32 object, uint32 event)
{
	char *buffer;
	int   size;
	Tserial_event *com;
	char   txt[512];

	com = (Tserial_event *) object;
	if (com!=0)
	{
		switch(event)
		{
			case  SERIAL_CONNECTED  :
				break;
			case  SERIAL_DISCONNECTED  :
				break;
			case  SERIAL_DATA_SENT  :
				tx_busy=false;
				break;
			case  SERIAL_DATA_ARRIVAL  :
				com->dataHasBeenRead();
				break;
		}
	}
}


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSendBox *SendBox;
//---------------------------------------------------------------------------
__fastcall TSendBox::TSendBox(TComponent* Owner)
	: TForm(Owner)
{
	serial_port.setManager(SerialEventManager);
	is_sending=false;
}

int c_send;
void TSendBox::put_serial (char *data)
{
	StatusBar1->SimpleText="Sending Data "+AnsiString(++c_send);
	while(tx_busy==true)
	{
		if(abort)
		{
			return;
		}
		Sleep(10);
	}
	tx_busy=true;
	serial_port.sendData(data, strlen(data));
}

void send_data( void *data)
{
	char buf[1024];
	PLTLIST *pnext;
	CORDLIST *cnext;
	int x,y;
	int lpen=-99;
	TSendBox *sb;
	sb=(TSendBox *)data;
	TMDIChild* mc;

	mc=dynamic_cast< TMDIChild* >( sb->MDIChild );

	c_send=0;
	sb->is_sending=true;
	sb->abort=false;
	sb->Abort->Enabled=true;
	sb->Exit->Enabled=false;
	sb->Send_Data->Enabled=false;
	pnext=mc->pltlist;

	while(pnext)
	{
		if(pnext->del==false)
		{
			if(pnext->cord && pnext->cord->next)
			{
				x=pnext->cord->x;
				y=pnext->cord->y;
				mc->transform_save(&x,&y);

				sprintf(buf,"PU;\n");
				sb->put_serial(buf);

				if(lpen!=pnext->pen)
				{
					lpen=pnext->pen;
					sprintf(buf,"SP %d;\n",pnext->pen);
					sb->put_serial(buf);
				}
				sprintf(buf,"PA %d,%d;\nPD;\n",x,y);
				sb->put_serial(buf);

				if(sb->abort)
				{
					break;
				}
				cnext=pnext->cord->next;
				while(cnext)
				{
					x=cnext->x;
					y=cnext->y;
					mc->transform_save(&x,&y);

					sprintf(buf,"PA %d,%d;\n",x,y);
					sb->put_serial(buf);

					cnext=cnext->next;
				}
			}
		}
		pnext=pnext->next;
	}
	sprintf(buf,"PU;\nPA 0,0;\n");
	sb->put_serial(buf);

	serial_port.disconnect();

	sb->Abort->Enabled=false;
	sb->Exit->Enabled=true;
	sb->Send_Data->Enabled=true;
	sb->is_sending=false;

	_endthread();
}

//---------------------------------------------------------------------------
void __fastcall TSendBox::Send_DataClick(TObject *Sender)
{
	int err;

	int par,flow;


	if(!is_sending)
	{
		flow=0;
		if(Flow_CTS->Checked) flow|=SERIAL_HS_CTS;
		if(Flow_DTR->Checked) flow|=SERIAL_HS_DTR;
		if(Flow_RTS->Checked) flow|=SERIAL_HS_RTS;
		if(Flow_DSR->Checked) flow|=SERIAL_HS_DSR;
		if(Flow_XON->Checked) flow|=SERIAL_HS_XON;

		switch(Parity->ItemIndex)
		{
			case 0:
				par=SERIAL_PARITY_ODD;
				break;
			case 1:
				par=SERIAL_PARITY_EVEN;
				break;
			case 2:
				par=SERIAL_PARITY_NONE;
				break;
		}

		if((err=serial_port.connect(Interface->Text.c_str(),atoi(Baudrate->Items->Strings[Baudrate->ItemIndex].c_str()),par,atoi(Bit->Items->Strings[Bit->ItemIndex].c_str()),flow,false))==0)
		{
			StatusBar1->SimpleText="Sending Data";
			_beginthread(send_data,4096,(void *)SendBox);
		}
		else
		{
			// error
			switch(err)
			{
				case 8:
					StatusBar1->SimpleText="Can't open "+Interface->Text+" ("+AnsiString(err)+")";
					break;
				default:
					StatusBar1->SimpleText="Error Initializing "+Interface->Text+" ("+AnsiString(err)+")";
					break;
			}
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TSendBox::AbortClick(TObject *Sender)
{
	abort=true;
}
//---------------------------------------------------------------------------

